/*
Copyright (C) 2005 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package drake;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

// compilation : javac -encoding ISO-8859-1 -d classes drake/Drake.java
//               jar cvf Drake.jar -C classes drake

public class Drake extends Applet implements ActionListener {
    
    Choice chF;
    String questionF = "Ft -  Taux de formation des toiles dans notre galaxie :";
    String[] titresF = { "5 toiles par an", "10 toiles par an", "15 toiles par an", "20 toiles par an"};
    double[] valF = { 5, 10, 15, 20 };
    
    Choice chPp;
    String questionPp = "Ppla - Proportion d'toiles ayant un systme plantaire :";
    String[] titresPp = { "toutes (100%)", "les trois quarts (75%)", "les deux tiers (66%)",
        "la moiti (50%)", "quatre sur dix (40%)", "trois sur dix (30%)", "deux sur dix (20%)",
        "une sur dix (10%)", "cinq sur cent (5%)", "une sur cent (1%)" };
    double[] valPp = { 1, 0.75, 0.66, 0.50, 0.40, 0.30, 0.20, 0.10, 0.05, 0.01 };
    
    Choice chNp;
    String questionNp = "Npla - Nombre moyen de plantes habitables par systme plantaire :";
    String[] titresNp = { "5", "4", "3", "2", "1", "(une pour dix systmes) 0.1", "(une pour cent systmes) 0.01", "une pour mille systmes" };
    double[] valNp = { 5, 4, 3, 2, 1, 0.1, 0.01, 0.001 };
    
    Choice chPv;
    String questionPv = "Pvie = Proportion des plantes habitables o la vie est apparue :";
    String[] titresPv = { "(toutes) 100%", "(la moiti) 50%", "(une sur dix) 10%", "(une sur cent) 1%",
        "(une sur mille) 0.1%" };
    double[] valPv = { 1, 0.5, 0.1, 0.01, 0.001 };
    
    Choice chPi;
    String questionPi = "Pint = proportion des plantes habites o l'intelligence est apparue :";
    String[] titresPi = { "(toutes) 100%", "(la moiti) 50%", "(une sur dix) 10%", "(une sur cent) 1%",
        "(une sur mille) 0.1 %", "(une sur dix mille) 0.01 %", "(une sur un million, ou 10^-6) 0.0001 %",
        "(une sur un milliard 10^-9) 10^-7%", "(une sur dix milliards) 10^-8%",
        "(une sur cent milliards) 10^-9%" };
    double[] valPi = { 1, 0.5, 0.1, 0.01, 1E-3, 1E-4, 1E-6, 1E-9, 1E-10, 1E-11};
    
    Choice chPc;
    String questionPc = "Pcom = proportion des civilisations qui communiquent avec l'espace :";
    String[] titresPc = { "(toutes) 100%", "(la moiti) 50%", "(une sur dix) 10%",
        "(une sur cent) 1%", "(une sur mille) 0.1 %", "(une sur 10000) 0.01 %",
        "(une sur un million, ou 10^-6) 0.00001 %", "(une sur un milliard 10^-9) 10^-7%",
        "(une sur dix milliards) 10^-8%", "(une sur cent milliards) 10^-9%" };
    double[] valPc = { 1, 0.5, 0.1, 0.01, 1E-3, 1E-4, 1E-6, 1E-9, 1E-10, 1E-11 };
    
    Choice chT;
    String questionT = "T - dure pendant laquelle une telle communication peut tre dtecte :";
    String[] titresT = { "cinq milliards d'annes", "un milliard d'annes",
        "cent millions d'annes", "dix millions d'annes", "un million d'annes",
        "mille ans", "100 ans" };
    double[] valT = { 5E9, 1E9, 1E8, 1E7, 1E6, 1E3, 1E2};
    
    public void init() {
        setLayout(new BorderLayout());
        TextArea ta = new TextArea("Choisissez une valeur pour chacun des termes de l'quation et voyez combien la Galaxie contient de civilisations prtes  communiquer.", 2, 50, TextArea.SCROLLBARS_NONE);
        ta.setEditable(false);
        add(ta, BorderLayout.NORTH);
        Panel grille = new Panel(new GridLayout(7, 1));
        Panel p;
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionF));
        chF = new Choice();
        chF.add("                  -                  ");
        for (int i=0; i<titresF.length; i++)
            chF.add(titresF[i]);
        p.add(chF);
        grille.add(p);
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionPp));
        chPp = new Choice();
        chPp.add("                  -                  ");
        for (int i=0; i<titresPp.length; i++)
            chPp.add(titresPp[i]);
        p.add(chPp);
        grille.add(p);
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionNp));
        chNp = new Choice();
        chNp.add("                  -                  ");
        for (int i=0; i<titresNp.length; i++)
            chNp.add(titresNp[i]);
        p.add(chNp);
        grille.add(p);
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionPv));
        chPv = new Choice();
        chPv.add("                  -                  ");
        for (int i=0; i<titresPv.length; i++)
            chPv.add(titresPv[i]);
        p.add(chPv);
        grille.add(p);
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionPi));
        chPi = new Choice();
        chPi.add("                  -                  ");
        for (int i=0; i<titresPi.length; i++)
            chPi.add(titresPi[i]);
        p.add(chPi);
        grille.add(p);
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionPc));
        chPc = new Choice();
        chPc.add("                  -                  ");
        for (int i=0; i<titresPc.length; i++)
            chPc.add(titresPc[i]);
        p.add(chPc);
        grille.add(p);
        
        p = new Panel(new FlowLayout(FlowLayout.LEFT));
        p.add(new Label(questionT));
        chT = new Choice();
        chT.add("                  -                  ");
        for (int i=0; i<titresT.length; i++)
            chT.add(titresT[i]);
        p.add(chT);
        grille.add(p);
        
        add(grille, BorderLayout.CENTER);
        
        p = new Panel(new FlowLayout(FlowLayout.CENTER));
        Button bcalc = new Button("calcul de l'quation de Drake");
        bcalc.setActionCommand("calcul");
        bcalc.addActionListener(this);
        p.add(bcalc);
        add(p, BorderLayout.SOUTH);
    }
    
    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if ("calcul".equals(cmd))
            calcul();
    }
    
    protected void calcul() {
        if (chF.getSelectedIndex() == 0 || chPp.getSelectedIndex() == 0 || chNp.getSelectedIndex() == 0 ||
                chPv.getSelectedIndex() == 0 || chPi.getSelectedIndex() == 0 || chPc.getSelectedIndex() == 0 ||
                chT.getSelectedIndex() == 0) {
            FResultat fres = new FResultat("Vous devez choisir une valeur pour chaque paramtre", "");
            fres.setVisible(true);
            return;
        }
        double ne = valF[chF.getSelectedIndex()-1];
        double pp = valPp[chPp.getSelectedIndex()-1];
        double np = valNp[chNp.getSelectedIndex()-1];
        double pv = valPv[chPv.getSelectedIndex()-1];
        double pi = valPi[chPi.getSelectedIndex()-1];
        double pc = valPc[chPc.getSelectedIndex()-1];
        double ps = valT[chT.getSelectedIndex()-1];
        double res = ne * pp * np * pv * pi * pc * ps;
        String l1 = "Le nombre de civilisations communicantes dans la Galaxie est :";
        String l2 = "Ft x Ppla x Npla x Pvie x Pint x Pcom x T = " + (long)Math.round(res);
        FResultat fres = new FResultat(l1, l2);
        fres.setVisible(true);
    }
    
    class FResultat extends Frame implements ActionListener {
        FResultat(String l1, String l2) {
            setLayout(new GridLayout(3,1));
            add(new Label(l1));
            add(new Label(l2));
            Panel pok = new Panel(new FlowLayout(FlowLayout.CENTER));
            Button bok = new Button("OK");
            bok.addActionListener(this);
            pok.add(bok);
            add(pok);
            pack();
            Dimension dim = getSize();
            Dimension ecran = getToolkit().getScreenSize();
            setLocation((ecran.width - dim.width)/2, (ecran.height - dim.height)/2);
        }
        public void actionPerformed(ActionEvent e) {
            setVisible(false);
        }
    }
}
